document.addEventListener('DOMContentLoaded', function() {
    // 获取按钮元素
    var zoomInButton = document.getElementById('zoomIn');
    var zoomOutButton = document.getElementById('zoomOut');

    // 为按钮添加点击事件监听器
    zoomInButton.addEventListener('click', function() {
        changeZoom(1.1); // 放大10%
    });

    zoomOutButton.addEventListener('click', function() {
        changeZoom(0.9); // 缩小10%
    });
});

function changeZoom(factor) {
    var viewport = document.querySelector('meta[name="viewport"]');
    if (viewport) {
        // 获取当前缩放级别
        var currentZoom = parseFloat(viewport.getAttribute('content').match(/initial-scale=([\d\.]+)/)[1]);
        // 计算新的缩放级别
        var newZoom = currentZoom * factor;
        // 更新视口的缩放级别
        viewport.setAttribute('content', 'width=device-width, initial-scale=' + newZoom + ', maximum-scale=' + newZoom + ', minimum-scale=' + newZoom + ', user-scalable=yes');
    }
}