//By 小鹏 当前版本 1.0
wszhuangtai = null;
function connectWebSocket() {
  if (wszhuangtai) return; 
  ws = new WebSocket('ws://lipenglei.com:8001');
  ws.addEventListener('open', () => {
    console.log('WebSocket 连接已建立');
    wszhuangtai = true;
    startCall();
    alert("连接服务器成功");
  });
  ws.addEventListener('close', () => {
    console.log('WebSocket 连接已关闭');
    wszhuangtai = null;
    if (!drawAnimationRunning) return; 
      setTimeout(connectWebSocket, 3000);
  });
  ws.addEventListener('message', (event) => {
    const dataArrayString = event.data; // 接收到的数据
    console.log(dataArrayString);
    playAudioFromArray(dataArrayString, ws); // 将 WebSocket 实例作为参数传递给函数
  });
}

const audioContext = new AudioContext();
const numChannels = 1; // 单声道
let audioBufferSource = null;
const gainFactor = 6; // 调整增益因子，可以根据需要调整
const lowPassFreq = 8001; // 低通滤波器的截止频率，可以根据需要调整
function createLowPassFilter() {
  const filter = audioContext.createBiquadFilter();
  filter.type = "lowpass";
  filter.frequency.value = lowPassFreq;
  return filter;
}

function playAudioFromArray(dataArrayString) {
  const dataArray = new Uint8Array(JSON.parse(dataArrayString)); // 将字符串转换为 Uint8Array
  const audioBuffer = audioContext.createBuffer(numChannels, dataArray.length, audioContext.sampleRate);
  const channelData = audioBuffer.getChannelData(0); // 获取第一个声道的数据
  // 将数据归一化到 [-1, 1] 的范围，并乘以增益因子
  for (let i = 0; i < dataArray.length; i++) {
      channelData[i] = ((dataArray[i] - 128) / 128) * gainFactor;
  }
  const lowPassFilter = createLowPassFilter();
  if (audioBufferSource) {
      audioBufferSource.stop();
  }
  audioBufferSource = audioContext.createBufferSource();
  audioBufferSource.buffer = audioBuffer;
  // 连接低通滤波器和目标
  audioBufferSource.connect(lowPassFilter);
  lowPassFilter.connect(audioContext.destination);
  audioBufferSource.start();
}

async function startCall() {
  localStream = await navigator.mediaDevices.getUserMedia({ audio: true });
  //本地播放
  /*const audioElement = document.getElementById('localAudio');
  audioElement.srcObject = localStream;
  console.log(localStream);*/
  const audioContext = new AudioContext();
  const source = audioContext.createMediaStreamSource(localStream);
  analyser = audioContext.createAnalyser();
  source.connect(analyser);
  // 将字符串转换为 Uint8Array
  const dataArray = new Uint8Array(analyser.frequencyBinCount);
  drawAnimationRunning = true; // 启动动画循环标志
  function draw() {
    if (!drawAnimationRunning) return; // 如果标志变量为 false，则停止动画循环
    if (!wszhuangtai) return; 
      analyser.getByteTimeDomainData(dataArray);
      // 这里可以使用 dataArray 中的音频数据进行自定义处理，比如可视化等
      const dataArrayString = JSON.stringify(Array.from(dataArray)); // 将 Uint8Array 转换为字符串
      // 计算音频数据的最大值
      const maxAmplitude = Math.max(...dataArray);
      if (maxAmplitude > 128) {
        // 本地播放
        //playAudioFromArray(dataArrayString);
        ws.send(dataArrayString);
        //console.log(maxAmplitude);
      }
      else{
        console.log(maxAmplitude);
      }
      //console.log(dataArrayString);
      requestAnimationFrame(draw);
  }
  draw();
}

function endCall() {
  drawAnimationRunning = null; // 停止动画循环
  if (localStream) {
    // 停止本地流中的所有轨道
    localStream.getTracks().forEach(track => track.stop());
    localStream = null;
    // 重置本地音频元素
    const localAudio = document.getElementById('localAudio');
    localAudio.srcObject = null;
    localAudio.pause();
    //关闭ws
    ws.close();
  }
}