self.addEventListener('install', function(event) {
    event.waitUntil(
        caches.open('my-cache').then(function(cache) {
            return cache.addAll([
                '../HTML/liulanqi.html', // 缓存浏览器
                // 其他需要缓存的资源
            ]);
        })
    );
});

self.addEventListener('fetch', function(event) {
    event.respondWith(
        caches.match(event.request).then(function(response) {
            // 如果缓存中有请求的资源，则直接返回
            if (response) {
                return response;
            }
            // 如果没有，则从网络获取
            return fetch(event.request);
        })
    );
});
