const buttons = document.querySelectorAll('#game-container button');
const resultElement = document.getElementById('result');

buttons.forEach(button => {
    button.addEventListener('click', function() {
        const playerChoice = this.id;
        const computerChoice = getComputerChoice();
        const result = determineWinner(playerChoice, computerChoice);
        resultElement.textContent = `你选择了 ${playerChoice}, 计算机选择了 ${computerChoice}. 结果: ${result}`;
    });
});

function getComputerChoice() {
    const choices = ['石头', '布', '剪刀'];
    return choices[Math.floor(Math.random() * choices.length)];
}

function determineWinner(player, computer) {
    if (player === computer) {
        return '平局';
    }
    if ((player === '石头' && computer === '剪刀') ||
        (player === '布' && computer === '石头') ||
        (player === '剪刀' && computer === '布')) {
        return '你赢了';
    }
    return '你输了';
}